const { platform } = require('os');
const { exec } = require('child_process');
const axios = require('axios')

const masterServerIP = 'smarteditingonline.solveigmm.com' // should be changed according to your installation
const baseURL = `https://${masterServerIP}`

// import media url could be set via command line argument
let url = 'https://smarteditingonline.solveigmm.com/files/test_video.mp4'
const myArgs = process.argv.slice(2)
if (myArgs.length){
    url = myArgs[0]
}

const axiosInst = axios.create({ baseURL })

const openChrome = url => {
    let command
    const osPlatform = platform()
    if (osPlatform === 'win32') {
        command = `start chrome ${url}`;
    } else if (osPlatform === 'darwin') {
        command = `open -a "Google Chrome" ${url}`;
    } else {
        command = `google-chrome --no-sandbox ${url}`;
    }
    exec(command);
}

const registerUser = async () => {
    try {
        const user = {
            name: 'Example user',
        }
        const resp = await axiosInst.post('/api/users', user)
        return resp.data.id
    } catch (e) {
        throw Error(`Error registerUser: ${e}`)
    }
}

const importFromUrl = async userId => {
    try {
        const headers = { 'Authorization': userId }
        await axiosInst.post('/api/import/media/url', {url}, { headers })
    } catch (e) {
        throw Error(`Error registerUser: ${e}`)
    }
}

const main = async () => {
    const userId = await registerUser()
    await importFromUrl(userId)
    const chromeUrl = `${baseURL}?session_id=${userId}`
    console.log(`open chrome with the url:  ${chromeUrl}`)
    openChrome(chromeUrl)
}

main()
