<?php

$masterServerIP = 'smarteditingonline.solveigmm.com'; // should be changed according to your installation
$baseURL = "https://$masterServerIP";

// import media URL could be set via command line argument
$url = 'https://smarteditingonline.solveigmm.com/files/test_video.mp4';
$myArgs = array_slice($argv, 1);
if (!empty($myArgs)) {
    $url = $myArgs[0];
}

function openChrome($url) {
    $osPlatform = strtolower(php_uname('s'));
    $command = '';

    if (strpos($osPlatform, 'win') !== false) {
        $command = "start chrome $url";
    } elseif (strpos($osPlatform, 'darwin') !== false) {
        $command = "open -a 'Google Chrome' $url";
    } else {
        $command = "google-chrome --no-sandbox $url";
    }

    shell_exec($command);
}

function sendRequest($url, $method = 'GET', $data = null, $headers = null) {
    $ch = curl_init();
    // Disable SSL certificate verification (not recommended for production)
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);

    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $method);

    if ($data !== null) {
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    }

    if ($headers !== null) {
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    }

    $response = curl_exec($ch);

    if ($response === false) {
        throw new Exception("cURL error: " . curl_error($ch));
    }

    curl_close($ch);

    return $response;
}

function registerUser() {
    global $baseURL;
    try {
        $user = ['name' => 'Example user'];
        $headers = ['Content-Type: application/json'];
        $response = sendRequest("$baseURL/api/users", 'POST', json_encode($user), $headers);
        $responseData = json_decode($response, true);
        return $responseData['id'];
    } catch (Exception $e) {
        throw new Exception("Error registerUser: " . $e->getMessage());
    }
}

function importFromUrl($userId) {
    global $baseURL, $url;
    try {
        $headers = ['Authorization: ' . $userId,
                    'Content-Type: application/json'];
        sendRequest("$baseURL/api/import/media/url", 'POST', json_encode(['url' => $url]), $headers);
    } catch (Exception $e) {
        throw new Exception("Error importFromUrl: " . $e->getMessage());
    }
}



function main() {
    global $baseURL;
    $userId = registerUser();
    importFromUrl($userId);
    $chromeUrl = "$baseURL?session_id=$userId";
    echo "Open Chrome with the URL: $chromeUrl\n";
    openChrome($chromeUrl);
}

if (basename(__FILE__) === basename($_SERVER["SCRIPT_FILENAME"])) {
    main();
}

?>
