import sys
import platform
import subprocess
import requests

master_server_ip = 'smarteditingonline.solveigmm.com'  # should be changed according to your installation
base_url = f'https://{master_server_ip}'

# import media URL could be set via command line argument
url = 'https://smarteditingonline.solveigmm.com/files/test_video.mp4'
my_args = sys.argv[1:]
if my_args:
    url = my_args[0]

axios_inst = requests.Session()
axios_inst.headers.update({'Content-Type': 'application/json', 'Accept': 'application/json'})
axios_inst.headers.update({'Authorization': ''})

def open_chrome(url):
    os_platform = platform.system().lower()
    if os_platform == 'windows':
        command = f'start chrome {url}'
    elif os_platform == 'darwin':
        command = f'open -a "Google Chrome" {url}'
    else:
        command = f'google-chrome --no-sandbox {url}'
    subprocess.run(command, shell=True)

def register_user():
    try:
        user = {'name': 'Example user'}
        resp = axios_inst.post(f'{base_url}/api/users', json=user)
        resp.raise_for_status()
        return resp.json()['id']
    except requests.exceptions.RequestException as e:
        raise Exception(f'Error register_user: {e}')

def import_from_url(user_id):
    try:
        headers = {'Authorization': user_id}
        axios_inst.post(f'{base_url}/api/import/media/url', json={'url': url}, headers=headers).raise_for_status()
    except requests.exceptions.RequestException as e:
        raise Exception(f'Error import_from_url: {e}')

def main():
    user_id = register_user()
    import_from_url(user_id)
    chrome_url = f'{base_url}?session_id={user_id}'
    print(f'Open Chrome with the URL: {chrome_url}')
    open_chrome(chrome_url)

if __name__ == '__main__':
    main()